// QView.cpp : implementation of the CQView class
//

#include "stdafx.h"
#include "Q.h"

#include "QDoc.h"
#include "QView.h"
#include "ConfirmEndTest.h"
#include "FioIdentDlg.h"
#include "ResultDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CQuestion

CQuestion::~CQuestion() 
{
	for (int i=0; i<wndarr.GetSize(); i++) {
		wndarr[i]->DestroyWindow();
		delete wndarr[i];
	}
}

void CQuestion::Add(CString cs,int t,int v1,int v2)
{
	strarr.Add(cs); typarr.Add(t);
	val1arr.Add(v1); val2arr.Add(v2);
}

int CQuestion::Num() 
{
	return strarr.GetSize();
}

int CQuestion::Calculate() 
{
	int retv=0;
	for (int i=0; i<Num(); i++) {
			switch (typarr[i]) {
			case CT_TEXT:  {
				break;
						   }
			case CT_RADIO: {
				CButton *st=(CButton *)wndarr[i];
				if (st->GetState()&0x3) retv+=val1arr[i];
				break;
						   }
			case CT_CHECK: {
				CButton *st=(CButton *)wndarr[i];
				if (st->GetState()&0x3) retv+=val1arr[i];
				else retv+=val2arr[i];
				break;
						   }
			default: {
				Beep(3000,100); AfxMessageBox("    ");
					 }
			}
	}
	return retv;
}

/////////////////////////////////////////////////////////////////////////////
// CQView

IMPLEMENT_DYNCREATE(CQView, CFormView)

BEGIN_MESSAGE_MAP(CQView, CFormView)
	//{{AFX_MSG_MAP(CQView)
	ON_COMMAND(ID_FILE_FORWARD, OnFileForward)
	ON_UPDATE_COMMAND_UI(ID_FILE_FORWARD, OnUpdateFileForward)
	ON_COMMAND(ID_FILE_BACKWARD, OnFileBackward)
	ON_UPDATE_COMMAND_UI(ID_FILE_BACKWARD, OnUpdateFileBackward)
	ON_COMMAND(ID_FILE_ENDTEST, OnFileEndtest)
	ON_UPDATE_COMMAND_UI(ID_FILE_ENDTEST, OnUpdateFileEndtest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQView construction/destruction

CQView::CQView()
	: CFormView(CQView::IDD)
{
	//{{AFX_DATA_INIT(CQView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_qcount=0;
}

CQView::~CQView()
{
}

void CQView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CQView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CFormView::PreCreateWindow(cs);
}

void CQView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CQView diagnostics

#ifdef _DEBUG
void CQView::AssertValid() const
{
	CFormView::AssertValid();
}

void CQView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CQDoc* CQView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CQDoc)));
	return (CQDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CQView message handlers

CString CQView::FileName()
{
	return GetDocument()->GetPathName();
}

void CQView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	for (int i=0; i<sq.GetSize(); i++) delete sq[i];
	sa.RemoveAll(); sq.RemoveAll(); m_qcount=0;
	if (FileName().GetLength()>0) {
		CString cs;
		CStdioFile file(FileName(),CFile::modeRead|CFile::shareDenyWrite|CFile::typeText);
		for (; file.ReadString(cs); ) {
			cs.OemToAnsi(); sa.Add(cs);
		}
		file.Close();
		
		CheckSynt();	//    
		PrepQuestions();//     
		AskQuest();		//  
	}
}

void CQView::OnFileForward() 
{
	// TODO: Add your command handler code here
	m_qcount++;
	AskQuest();
}

void CQView::OnUpdateFileForward(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(FileName().GetLength()>0 && sq.GetSize()>m_qcount+1);
}

void CQView::OnFileBackward() 
{
	// TODO: Add your command handler code here
	m_qcount--;
	AskQuest();
}

void CQView::OnUpdateFileBackward(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(FileName().GetLength()>0 && m_qcount>0);
}

void CQView::OnFileEndtest() 
{
	int ball=0;
	CConfirmEndTest dlg;
	if (dlg.DoModal()==IDOK) {
		CFioIdentDlg id;
retry:
		if (id.DoModal()==IDOK) {
			//   
			CResultDlg res; CString cs;
			res.m_text= "  :\r\n";
			res.m_text+="\r\n";
			res.m_text+="  "+
				CTime::GetCurrentTime().Format("%d %B %Y  (%H:%M")+"\r\n";
			res.m_text+="\r\n";
			res.m_text+="    : "+id.m_fname+"\r\n";
			res.m_text+="    :     "+id.m_name+"\r\n";
			cs.Format(  "    :   %d-'%c' \r\n",id.m_class+1,id.m_class_letter+'');
			res.m_text+=cs;
			res.m_text+="\r\n";

			res.m_text+="-----\r\n";
			ball=0;
			for (int i=0; i<sq.GetSize(); i++) {
				ball+=sq[i]->Calculate();
				cs.Format(" %2d,   %5d\r\n",i+1,sq[i]->Calculate());
				res.m_text+=cs;
				//    
				//for (int j=0; j<sq[i]->Num(); j++) {
				//	cs.Format("      val1arr=%5d, val2arr=%5d\r\n",sq[i]->val1arr[j],sq[i]->val2arr[j]);
				//	res.m_text+=cs;
				//}
			}
			res.m_text+="-----\r\n";
			cs.Format("   : %d\r\n",ball);
			res.m_text+=cs;

			
			Beep(3000,100); res.DoModal();

		} else goto retry;


	}
}

void CQView::OnUpdateFileEndtest(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(FileName().GetLength()>0);
}

void CQView::AskQuest()
{
	if (m_qcount<sq.GetSize()) {
		CQuestion *q;

		//       
		for (int j=0; j<sq.GetSize(); j++) {
			q=sq[j];
			for (int i=0; i<q->Num(); i++) {
				if (j==m_qcount) q->wndarr[i]->ShowWindow(SW_SHOW);
				else  q->wndarr[i]->ShowWindow(SW_HIDE);
			}
		}
	}
}


void CQView::CheckSynt()
{
	CString cs;
	int k=0;
	BOOL err=TRUE;
	int val1=0,val2=0;
	CQuestion *q=NULL;

	for (int i=0; i<sa.GetSize(); i++) {
		cs=sa[i]; cs.TrimLeft(" \t"); cs.TrimRight(" \t");

		//    
		if (cs.GetLength()==0) continue;	//   
		if (cs[0]=='#') continue;			//  
		while ((k=cs.ReverseFind('#'))!=-1) cs=cs.Left(k);

		//     
		if (cs[0]!='@') {
			cs.Format(" , %d",i+1); Beep(3000,100);
			AfxMessageBox("    "+cs);
			break;
		}

		cs.MakeUpper(); err=TRUE;

		// ---       

		// QUESTION    
		if (cs.Find("@QUESTION")==0) {
			if (cs.Find("RADIO")>0) {
				//  
				if (q!=NULL) sq.Add(q);
				q=new CQuestion;
				err=FALSE;
			}
			if (cs.Find("CHECK")>0) {
				//  
				if (q!=NULL) sq.Add(q);
				q=new CQuestion;
				err=FALSE;
			}
			//  
			if (err) {
				cs.Format(" , %d",i+1); Beep(3000,100);
				AfxMessageBox("   'QUESTION'"+cs);
				break;
			}
			err=FALSE; continue;
		}

		// TEXT      
		if (cs.Find("@TEXT")==0) {
			int i1,i2;
			i1=cs.Find('"'); i2=cs.ReverseFind('"');
			if (i1==i2 || i1==-1) {
				cs.Format(" , %d",i+1); Beep(3000,100);
				AfxMessageBox("   'TEXT'"+cs);
				break;
			}
			cs=cs.Mid(i1+1,i2-i1-1);
			q->Add(cs,CT_TEXT,0,0);
			//  
			err=FALSE; continue;
		}

		// CASE   radio-button-
		if (cs.Find("@CASE")==0) {
			int i1,i2;
			i1=cs.Find('"'); i2=cs.ReverseFind('"');
			if (i1==i2 || i1==-1) {
				cs.Format(" , %d",i+1); Beep(3000,100);
				AfxMessageBox("   'CASE'"+cs);
				break;
			}
			cs=cs.Mid(i1+1,i2-i1-1);
			for (k=strlen("@CASE"); !isdigit(sa[i][k]) && sa[i][k]!='-'; k++) ;
			val1=atoi(((LPCSTR)sa[i])+k);	// 
			//  
			q->Add(cs,CT_RADIO,val1,0);
			err=FALSE; continue;
		}

		// ITEM   checkbox-
		if (cs.Find("@ITEM")==0) {
			int i1,i2;
			i1=cs.Find('"'); i2=cs.ReverseFind('"');
			if (i1==i2 || i1==-1) {
				cs.Format(" , %d",i+1); Beep(3000,100);
				AfxMessageBox("   'CASE'"+cs);
				break;
			}
			cs=cs.Mid(i1+1,i2-i1-1);
			for (k=strlen("@ITEM"); !isdigit(sa[i][k]) && sa[i][k]!='-'; k++) ;
			val1=atoi(((LPCSTR)sa[i])+k);	//    
			for (; isdigit(sa[i][k]) || sa[i][k]=='-'; k++) ;
			for (; !isdigit(sa[i][k]) && sa[i][k]!='-'; k++) ;
			val2=atoi(((LPCSTR)sa[i])+k);	//   
			//  
			q->Add(cs,CT_CHECK,val1,val2);
			err=FALSE; continue;
		}

		//     
		if (err) {
			cs.Format(" , %d",i+1); Beep(3000,100);
			AfxMessageBox("  "+cs);
			break;
		}
	}

	//   
	if (q!=NULL) sq.Add(q);
	err=FALSE;

	//      
	SYSTEMTIME st; GetSystemTime(&st);
	srand(st.wSecond*st.wMilliseconds);
	int i1=0;
	for (i1=0; i1<sq.GetSize(); i1++) {
		m_index.Add(rand());
	}
	//   
	for (i1=0; i1<sq.GetSize(); i1++) {
		m_index.Add(rand());
	}

}


void CQView::PrepQuestions()
{
#define ROW_YOFFS	15
#define ROW_WIDTH	20
#define ROW_MARGIN	25

	if (sq.GetSize()<1) return;
	for (int j=0; j<sq.GetSize(); j++) {
		CQuestion *q;
		q=sq[j];
		for (int i=0; i<q->Num(); i++) {
			switch (q->typarr[i]) {
			case CT_TEXT:  {
				CStatic *st=new CStatic();
				st->Create(q->strarr[i],WS_CHILD,CRect(ROW_MARGIN,i*ROW_WIDTH+ROW_YOFFS,1000,(i+1)*ROW_WIDTH+ROW_YOFFS),this);
				q->wndarr.Add(st);
				break;
						   }
			case CT_RADIO: {
				CButton *st=new CButton();
				st->Create(q->strarr[i],WS_CHILD|BS_AUTORADIOBUTTON,CRect(ROW_MARGIN,i*ROW_WIDTH+ROW_YOFFS,1000,(i+1)*ROW_WIDTH+ROW_YOFFS),this,0);
				q->wndarr.Add(st);
				break;
						   }
			case CT_CHECK: {
				CButton *st=new CButton();
				st->Create(q->strarr[i],WS_CHILD|BS_AUTOCHECKBOX,CRect(ROW_MARGIN,i*ROW_WIDTH+ROW_YOFFS,1000,(i+1)*ROW_WIDTH+ROW_YOFFS),this,0);
				q->wndarr.Add(st);
				break;
						   }
			default: {
				Beep(3000,100); AfxMessageBox("  ");
					 }
			}

		}

	}
}
